@use '../../../easings' as easings;
@use '../../../queries' as queries;

@keyframes grid-element-fade-in {
  from {
    filter: opacity(0);
  }
  to {
    filter: opacity(1);
  }
}

:host {
  position: relative;
  animation: grid-element-fade-in 1s ease-out 1 0s both;
  display: flex;
  flex-direction: column;
  align-items: stretch;
}

.entity-type {
  color: white;
  display: flex;
  justify-content: flex-end;
  position: absolute;
  z-index: 2;
  right: 0;
  bottom: 2.1rem;
  font-size: 1rem;
  padding: 0.2rem 0.1rem 0.2rem 0.2rem;
  background: rgba(0, 0, 0, 0.2);
  border-radius: 0.2rem;

  mat-icon {
    display: flex;
    justify-content: center;
    align-items: center;
    font-size: 1.2rem;
  }

  @include queries.small() {
    display: none;
  }
}

.title {
  font-size: 0.8rem;
  box-sizing: border-box;
  text-decoration: none;
  z-index: 1;
  color: #333;
  width: 100%;
  padding: 0.5rem 1rem;
  position: relative;
  background: rgba(255, 255, 255, 0.5);
  text-align: center;
  display: flex;
  > div {
    overflow: hidden;
    white-space: nowrap;
    text-overflow: ellipsis;
    flex-grow: 1;
    width: 0;
  }
  &:after {
    position: absolute;
    content: '';
    bottom: 0;
    left: 50%;
    transform: translateX(-50%);
    width: 0%;
    height: 0.1rem;
    transition: width 500ms easings.$easeOutQuint;
    background: #00afe7;
    border-radius: 0.25rem;
  }
}

:host:hover {
  .title:after {
    width: 60%;
  }
}

.image,
.images {
  flex-grow: 1;
  display: flex;
  justify-content: center;
  align-items: center;

  overflow: hidden;
  border-radius: 0.2rem;
  position: relative;
  &:before {
    border-radius: 0.2rem;
    position: absolute;
    content: '';
    width: 100%;
    height: 100%;
    top: 0;
    left: 0;
    transition: clip-path 950ms easings.$easeOutQuart;
    transition-delay: 100ms;
    background: var(--bg-color);
    clip-path: circle(0%);
  }
  &:hover:before {
    clip-path: circle(100%);
  }
}

.image {
  flex-grow: 1;
  display: flex;
  justify-content: center;
  align-items: center;
}

::ng-deep {
  .image {
    img {
      aspect-ratio: 16/10;
      transform: scale(0.9);
      filter: contrast(0.8) saturate(0.95);
      transition: filter 750ms easings.$easeOutQuart, transform 750ms easings.$easeOutQuart,
        clip-path 750ms easings.$easeOutQuart !important;
    }

    &:hover {
      img {
        transform: scale(1);
        filter: contrast(1) saturate(1.05);
      }
    }
  }
}

.images {
  display: grid;
  grid-template-columns: repeat(2, 1fr);
  grid-template-rows: 1fr 1fr;
  grid-gap: 1rem;
  border-top-left-radius: 0.25rem;
  border-top-right-radius: 0.25rem;

  &.single-image {
    grid-template-columns: 1fr;
    grid-template-rows: 1fr;
    grid-gap: 0;
  }

  anim-img {
    transform: scale(1.1) !important;
    overflow: hidden;
    width: 100%;
  }

  img {
    filter: drop-shadow(0px 1px 0px gray) saturate(1.2);
  }
}
